
******************************************************************************
* SHOOT - (C) JOHN A. BRISTOR ,1987
* ALL RIGHTS RESERVED
*
* 8414 Williamsburg Circle
* Pensacola, FL 32514
* Voice (904) 474-8846
* Data (704) 264-7381	FIDO : 151/305
*
* This program maybe used in this or modified form in any application by
*      anybody who so desires but please give me credit. If you find this
*      program useful and use it to make a buck, please feel free to send
*      women, money, food or clothing or at least drop me a line and let
*      me know your comments.
*
* Program to 'Point and Shoot' from database file - After locating
*      record in file, user can select the record in the file to pass
*      any or all record information to calling program.
*
* Program can easily be changed to accomodate any file by just passing the
*      parameters for Window Placement, Window Size, Field Titles,
*      foreground/backround colors, Type of box around window (if any)
*
* Definable Pointer scrolls up and down inside window, but when reaches top
*      or bottom the pointer becomes stationary and the fields scroll
*      in the window
*
* Only restrictions on this version are : Parameters passed shouldn't
*      interfere with screen dimensions; total records in file or array
*      should be greater than or equal to BOXLINES
*
* Program should be setup to return Recno() or Array position or actual field
*      values when enclosed in actual application  Ŀ
*							       
* Keys :						       
*	 Down Arrow - Next Record or Array position	       
*	 Up Arrow - Previous Record			       
*	 Home - Beginning of Record			       
*	 End -	Bottom of Record			       
*	 PgUp - Move up one Page			       
*	 PgDn - Move Down one Page			       
*	 Enter/Return - Should return value of 
*	 Esc - Should return to calling program with no values
*
*
* PROGRAM STARTUP ====>   SHOOT filename area
*
*     filename : Name of Database file to be used, can have any extension
*     area : File Area to Open file
*
* SHOOT.EXE : Procedure SP035
*
*	   SHOOT.PRG : Point and Shoot engine
*	   SETUP.PRG : Initialization Module  (Output : SHOOT.MEM)
*	   FILL.PRG  : Fills window with record information.
*
* SHOOT.DTA : Sample File for Demo
* DEMO.BAT :  To Start Demo
* SCRL.OBJ : ASM Scroll Routine by (SCRL.ASM) by Thomas E. Link
* SHOOT.MEM :  Contains all Parameters passed into mainline procedure * * This is a standard routine for displaying scrolling messages from left * to right.  * * PARAMETERS :	* PBANNER --> String containing message * MIN.	Length - 2 chars * MAX.
*
* COMPILER - Clipper, Winter'85, Autumn'86
* LINKING -  Must be Linked with SCRL.OBJ
******************************************************************************

PARAMETERS PFILE,PAREA
CLEAR		    && Screen Conditions should be handled by calling program
IF PCOUNT() <> 2
     ? "Invalid Parameters..."
     RETURN
ENDIF
IF .not. FILE(PFILE) .AND. PCOUNT() <> 2
     ? "File Not Found..."
     RETURN
ENDIF
IF '123456789ABCDEFGHIJ'$UPPER(PAREA)   && Enough for Starters
     ? "Invalid File Area..."
     RETURN
ENDIF
IF AT('.',PFILE) <> 0
     STORE AT('.',PFILE) TO POS
     STORE SUBSTR(PFILE,1,POS-1) + ".MEM" TO MEMFILE
ELSE
     STORE TRIM(PFILE) + ".MEM" TO MEMFILE
ENDIF
SELECT &PAREA
USE &PFILE
IF .NOT. FILE(MEMFILE)
     COPY STRU EXTENDED TO SHOOT.TMP
     STORE "SHOOT.TMP" TO JUNKFILE
     DO SETUP WITH JUNKFILE
     ERASE SHOOT.TMP
     USE &PFILE
*    SET INDEX TO
*    SET ORDER TO
     RESTORE FROM &MEMFILE ADDITIVE
ELSE
     RESTORE FROM &MEMFILE ADDITIVE
     USE &PFILE
*    SET INDEX TO
*    SET ORDER TO
ENDIF

STORE 0 TO LC			      && Initialize a Line Counter for Rows
STORE RECCOUNT() TO TOTREC	      && Number of records in file/table
STORE ZZBTOP+2 TO LCT			&& First Display Row in Window
STORE ZZBOTTOM - ZZBTOP - 2 TO BOXLINES  && Number of records displayed in Window
STORE ZZBOTTOM - 1 TO LCB	       && Last Display Row in Window
STORE ZZBLEFT + 2 TO LCL		&& First Display Column in Window
STORE ZZBRIGHT-1 TO LCR 		&& Last Display Column in Window
STORE ZZBLEFT+1 TO OLDCOL		&& Initialize Pointer Column (CONSTANT)

SET COLOR TO &ZZFORE/&ZZBACK
@ ZZBTOP,ZZBLEFT CLEAR TO ZZBOTTOM,ZZBRIGHT
@ ZZBTOP,ZZBLEFT,ZZBOTTOM,ZZBRIGHT BOX ZZBOX
SET COLOR TO &ZZBACK/&ZZFORE
@  ZZBTOP+1,ZZBLEFT+1 SAY ZZTITLE
SET COLOR TO &ZZFORE/&ZZBACK
DO FILL

STORE LCT TO OLDROW		      && Pointer Row Position Flag
STORE (-1 * BOXLINES) TO DEVIATE      && Initialize Pointer - Record Deviation

SET COLOR TO &ZZBFORE/&ZZBACK
@ OLDROW,OLDCOL SAY ZZPOINTER
SET COLOR TO &ZZFORE/&ZZBACK

*DO WHILE LASTKEY() <> 13 .AND. LASTKEY() <> 27  && Replaces following line
DO WHILE LASTKEY() <> 27			 && in actual applications
     INKEY(0)
     DO CASE
	  CASE LASTKEY() = 3
	       SKIP BOXLINES
	       IF .NOT. EOF()
		    SKIP (-1 * BOXLINES)
		    DO FILL
	       ELSE
		    GO BOTTOM
		    SKIP (BOXLINES * -1)
		    DO FILL
		    @ OLDROW,OLDCOL SAY SPACE(LEN(ZZPOINTER))
		    STORE LCB TO OLDROW
		    SET COLOR TO &ZZBFORE/&ZZBACK
		    @ OLDROW,OLDCOL SAY ZZPOINTER
		    SET COLOR TO &ZZFORE/&ZZBACK
		    STORE -1 TO DEVIATE
	       ENDIF

	  CASE LASTKEY() = 18
	       SKIP (BOXLINES * -2)
	       IF BOF()
		    @ OLDROW,OLDCOL SAY SPACE(LEN(ZZPOINTER))
		    STORE LCT TO OLDROW
		    SET COLOR TO &ZZBFORE/&ZZBACK
		    @ OLDROW,OLDCOL SAY ZZPOINTER
		    SET COLOR TO &ZZFORE/&ZZBACK
		    STORE (-1 * BOXLINES) TO DEVIATE
	       ENDIF
	       DO FILL

	  CASE LASTKEY() = 1
	       GO TOP
	       @ OLDROW,OLDCOL SAY SPACE(LEN(ZZPOINTER))
	       STORE LCT TO OLDROW
	       SET COLOR TO &ZZBFORE/&ZZBACK
	       @ OLDROW,OLDCOL SAY ZZPOINTER
	       SET COLOR TO &ZZFORE/&ZZBACK
	       DO FILL
	       STORE (-1 * BOXLINES) TO DEVIATE

	  CASE LASTKEY() = 6
	       GO BOTTOM
	       @ OLDROW,OLDCOL SAY SPACE(LEN(ZZPOINTER))
	       STORE LCB TO OLDROW
	       SET COLOR TO &ZZBFORE/&ZZBACK
	       @ OLDROW,OLDCOL SAY ZZPOINTER
	       SET COLOR TO &ZZFORE/&ZZBACK
	       SKIP ((BOXLINES - 1) * -1)
	       DO FILL
	       STORE -1 TO DEVIATE

	  CASE LASTKEY() = 24
	       IF .NOT. EOF()
		   IF OLDROW <> LCB
			@ OLDROW,OLDCOL SAY SPACE(LEN(ZZPOINTER))
			STORE OLDROW+1 TO OLDROW
			SET COLOR TO &ZZBFORE/&ZZBACK
			@ OLDROW,OLDCOL SAY ZZPOINTER
			SET COLOR TO &ZZFORE/&ZZBACK
			STORE DEVIATE + 1 TO DEVIATE
		   ELSE
			@ OLDROW-1,OLDCOL SAY SPACE(LEN(ZZPOINTER))
			SET COLOR TO &ZZBFORE/&ZZBACK
			@ OLDROW,OLDCOL SAY ZZPOINTER
			SET COLOR TO &ZZFORE/&ZZBACK
			call ascroll with chr(6),chr(1),chr(15),chr(LCT),chr(LCL),chr(LCB),chr(LCR)
			@  LCB,LCL SAY &ZZDISPLAY
			SKIP
			STORE -1 TO DEVIATE
		   ENDIF
	       ENDIF

	  CASE LASTKEY() = 5
		   IF OLDROW <> LCT .AND. .NOT. BOF()
			@ OLDROW,OLDCOL SAY SPACE(LEN(ZZPOINTER))
			STORE OLDROW-1 TO OLDROW
			SET COLOR TO &ZZBFORE/&ZZBACK
			@ OLDROW,OLDCOL SAY ZZPOINTER
			SET COLOR TO &ZZFORE/&ZZBACK
			STORE DEVIATE - 1 TO DEVIATE
		   ELSE
			IF OLDROW = LCT
			     SKIP (-1 * (BOXLINES + 1))
			     IF .NOT. BOF()
				  @ OLDROW+1,OLDCOL SAY SPACE(LEN(ZZPOINTER))
				  SET COLOR TO &ZZBFORE/&ZZBACK
				  @ OLDROW,OLDCOL SAY ZZPOINTER
				  SET COLOR TO &ZZFORE/&ZZBACK
				  call ascroll with chr(7),chr(1),chr(15),chr(LCT),chr(LCL),chr(LCB),chr(LCR)
				  @  LCT, LCL SAY &ZZDISPLAY
				  SKIP (BOXLINES)
				  STORE (-1 * (LC-LCT)) TO DEVIATE
			     ELSE
				  SKIP BOXLINES
				  STORE (-1 * BOXLINES) TO DEVIATE
			     ENDIF
			ENDIF
		   ENDIF

	  CASE LASTKEY() = 13
	       SKIP DEVIATE
	       @ 23, 0 CLEAR
	       @ 23,10 SAY AREACODE +"  "+LOCATION
	       SKIP (-1 * DEVIATE)

	  CASE LASTKEY() = 27

     ENDCASE
ENDDO
RETURN
